//リンクファイルのフォルダを一括で変える
//----------------------------------------------------
//設定
//----------------------------------------------------

//フォルダ指定方法
//1ならフォルダ選択ダイアログ、2ならプロンプトで直接入力
var FileSelect = 1;

//----------------------------------------------------

var P = app.activeDocument.placedItems;
start_flag = true;


CheckLinkFileName(P);

if (start_flag == false) {

}else{
    LinkChangeDir(P);//実行
}


//----------------------------------------------------
//関数
//----------------------------------------------------


//現在のリンクパスを確認、比較
function CheckLinkFileName(P)
{
    fileName = [];
    flagDir = [];
    var n = P.length;
    for (var i=0; i<n; i++)
    {
        var setName = P[i].file;
        setName = String(setName);
        var reg = /^.*\//;//パスを取得
        dir = setName.match(reg);//パスを取得

        flagDir.push(dir);//パスが一致するか確認用記録
        if(i>0){
            if(String(flagDir[i]) != String(flagDir[0])){
               alert("フォルダが違う画像が混ざっています\nスクリプトを終了します");
               start_flag = false;
            }
        }

        var file = setName.replace( reg , "" );//パス以外=ファイル名を取得
        fileName.push(file);

    }
 }

//リンクパスを変更
function LinkChangeDir(P)
{

    switch( FileSelect ){
        case 1:
            var dir = Folder.selectDialog("変更するフォルダを選択して下さい",dir);
            var setDir = dir + "/";
            break;

        case 2:
            var dir = prompt("リンクを変更します\nフォルダパスを指定してください",dir);
            var setDir = dir; //プロンプト直接入力の場合
            break;

        default:
            alert("フォルダ設定変数が正しく設定されていません");
            break;
    }

    var n = P.length;
    for (var i=0; i<n; i++)
    {
        var newDir = setDir + fileName[i]; 
        P[i].file = File(newDir);
    }
}